diff --git a/kdeui/itemviews/kcategorizedview.cpp b/kdeui/itemviews/kcategorizedview.cpp
index 4b30859..005102a 100644
--- a/kdeui/itemviews/kcategorizedview.cpp
+++ b/kdeui/itemviews/kcategorizedview.cpp
@@ -1,6 +1,6 @@
 /**
   * This file is part of the KDE project
-  * Copyright (C) 2007 Rafael Fernández López <ereslibre@kde.org>
+  * Copyright (C) 2007, 2008 Rafael Fernández López <ereslibre@kde.org>
   *
   * This library is free software; you can redistribute it and/or
   * modify it under the terms of the GNU Library General Public
@@ -33,21 +33,19 @@
 #include "kcategorydrawer.h"
 #include "kcategorizedsortfilterproxymodel.h"
 
-// By defining DOLPHIN_DRAGANDDROP the custom drag and drop implementation of
-// KCategorizedView is bypassed to have a consistent drag and drop look for all
-// views. Hopefully transparent pixmaps for drag objects will be supported in
-// Qt 4.4, so that this workaround can be skipped.
-#define DOLPHIN_DRAGANDDROP
+//BEGIN: Private part
 
-KCategorizedView::Private::Private(KCategorizedView *listView)
-    : listView(listView)
-    , categoryDrawer(0)
-    , biggestItemSize(QSize(0, 0))
-    , mouseButtonPressed(false)
-    , rightMouseButtonPressed(false)
-    , isDragging(false)
-    , dragLeftViewport(false)
+KCategorizedView::Private::Private(KCategorizedView *q)
+    : q(q)
     , proxyModel(0)
+    , categoryDrawer(0)
+    , categoryDrawerV2(0)
+    , categorySpacing(5)
+    , alternatingBlockColors(false)
+    , collapsibleBlocks(false)
+    , hoveredIndex(QModelIndex())
+    , pressedPosition(QPoint())
+    , rubberBandRect(QRect())
 {
 }
 
@@ -55,483 +53,325 @@ KCategorizedView::Private::~Private()
 {
 }
 
-const QModelIndexList &KCategorizedView::Private::intersectionSet(const QRect &rect)
+bool KCategorizedView::Private::isCategorized() const
 {
-    QModelIndex index;
-    QRect indexVisualRect;
-
-    intersectedIndexes.clear();
+    return proxyModel && categoryDrawer && proxyModel->isCategorizedModel() &&
+           q->flow() == QListView::LeftToRight;
+}
 
-    int itemHeight;
+QPair<QModelIndex, QModelIndex> KCategorizedView::Private::intersectingIndexesWithRect(const QRect &_rect) const
+{
+    const int rowCount = proxyModel->rowCount();
 
-    if (listView->gridSize().isEmpty())
-    {
-        itemHeight = biggestItemSize.height();
-    }
-    else
-    {
-        itemHeight = listView->gridSize().height();
-    }
+    const QRect rect = _rect.normalized();
 
-    // Lets find out where we should start
-    int top = proxyModel->rowCount() - 1;
+    // binary search to find out the top border
     int bottom = 0;
-    int middle = (top + bottom) / 2;
-    while (bottom <= top)
-    {
-        middle = (top + bottom) / 2;
-
-        index = proxyModel->index(middle, 0);
-        indexVisualRect = visualRect(index);
-        // We need the whole height (not only the visualRect). This will help us to update
-        // all needed indexes correctly (ereslibre)
-        indexVisualRect.setHeight(indexVisualRect.height() + (itemHeight - indexVisualRect.height()));
-
-        if (qMax(indexVisualRect.topLeft().y(),
-                 indexVisualRect.bottomRight().y()) < qMin(rect.topLeft().y(),
-                                                           rect.bottomRight().y()))
-        {
+    int top = rowCount - 1;
+    while (bottom <= top) {
+        const int middle = (bottom + top) / 2;
+        const QModelIndex index = proxyModel->index(middle, q->modelColumn(), q->rootIndex());
+        QRect itemRect = q->visualRect(index);
+        const int verticalOff = q->verticalOffset();
+        const int horizontalOff = q->horizontalOffset();
+        itemRect.topLeft().ry() += verticalOff;
+        itemRect.topLeft().rx() += horizontalOff;
+        itemRect.bottomRight().ry() += verticalOff;
+        itemRect.bottomRight().rx() += horizontalOff;
+        if (itemRect.bottomRight().y() <= rect.topLeft().y()) {
             bottom = middle + 1;
-        }
-        else
-        {
+        } else {
             top = middle - 1;
         }
     }
 
-    for (int i = middle; i < proxyModel->rowCount(); i++)
-    {
-        index = proxyModel->index(i, 0);
-        indexVisualRect = visualRect(index);
-
-        if (rect.intersects(indexVisualRect))
-            intersectedIndexes.append(index);
-
-        // If we passed next item, stop searching for hits
-        if (qMax(rect.bottomRight().y(), rect.topLeft().y()) <
-                                                  qMin(indexVisualRect.topLeft().y(),
-                                                       indexVisualRect.bottomRight().y()))
-            break;
+    const QModelIndex bottomIndex = proxyModel->index(bottom, q->modelColumn(), q->rootIndex());
+
+    // binary search to find out the bottom border
+    bottom = 0;
+    top = rowCount - 1;
+    while (bottom <= top) {
+        const int middle = (bottom + top) / 2;
+        const QModelIndex index = proxyModel->index(middle, q->modelColumn(), q->rootIndex());
+        QRect itemRect = q->visualRect(index);
+        const int verticalOff = q->verticalOffset();
+        const int horizontalOff = q->horizontalOffset();
+        itemRect.topLeft().ry() += verticalOff;
+        itemRect.topLeft().rx() += horizontalOff;
+        itemRect.bottomRight().ry() += verticalOff;
+        itemRect.bottomRight().rx() += horizontalOff;
+        if (itemRect.topLeft().y() <= rect.bottomRight().y()) {
+            bottom = middle + 1;
+        } else {
+            top = middle - 1;
+        }
     }
 
-    return intersectedIndexes;
+    const QModelIndex topIndex = proxyModel->index(top, q->modelColumn(), q->rootIndex());
+
+    return qMakePair(bottomIndex, topIndex);
 }
 
-QRect KCategorizedView::Private::visualRectInViewport(const QModelIndex &index) const
+struct KCategorizedView::Private::Item
 {
-    if (!index.isValid())
-        return QRect();
-
-    QString curCategory = elementsInfo[index.row()].category;
-
-    QRect retRect;
-    const bool leftToRightFlow = (listView->flow() == QListView::LeftToRight);
-    
-    if (leftToRightFlow)
-    {
-        if (listView->layoutDirection() == Qt::LeftToRight)
-        {
-            retRect = QRect(listView->spacing(), listView->spacing() * 2 +
-                            categoryDrawer->categoryHeight(index, listView->viewOptions()), 0, 0);
-        }
-        else
-        {
-            retRect = QRect(listView->viewport()->width() - listView->spacing(), listView->spacing() * 2 +
-                            categoryDrawer->categoryHeight(index, listView->viewOptions()), 0, 0);
-        }
-    }
-    else
+    Item()
+        : topLeft(QPoint())
+        , size(QSize())
     {
-        retRect = QRect(listView->spacing(), listView->spacing() * 2 +
-                        categoryDrawer->categoryHeight(index, listView->viewOptions()), 0, 0);
     }
 
-    int viewportWidth = listView->viewport()->width() - listView->spacing();
+    QPoint topLeft;
+    QSize size;
+};
 
-    int itemHeight;
-    int itemWidth;
+struct KCategorizedView::Private::Block
+{
+    Block()
+        : topLeft(QPoint())
+        , height(-1)
+        , firstIndex(QModelIndex())
+        , quarantineStart(QModelIndex())
+        , items(QList<Item>())
+        , outOfQuarantine(false)
+        , alternate(false)
+        , collapsed(false)
+    {
+    }
+
+    static bool lessThan(const Block &left, const Block &right)
+    {
+        Q_ASSERT(left.firstIndex.isValid());
+        Q_ASSERT(right.firstIndex.isValid());
+        return left.firstIndex.row() < right.firstIndex.row();
+    }
+
+    QPoint topLeft;
+    int height;
+    QPersistentModelIndex firstIndex;
+    // if we have n elements on this block, and we inserted an element at position i. The quarantine
+    // will start at index (i, column, parent). This means that for all elements j where i <= j <= n, the
+    // visual rect position of item j will have to be recomputed (cannot use the cached point). The quarantine
+    // will only affect the current block, since the rest of blocks can be affected only in the way
+    // that the whole block will have different offset, but items will keep the same relative position
+    // in terms of their parent blocks.
+    QPersistentModelIndex quarantineStart;
+    QList<Item> items;
+
+    // this affects the whole block, not items separately. items contain the topLeft point relative
+    // to the block. Because of insertions or removals a whole block can be moved, so the whole block
+    // will enter in quarantine, what is faster than moving all items in absolute terms.
+    bool outOfQuarantine;
+
+    // should we alternate its color ? is just a hint, could not be used
+    bool alternate;
+    bool collapsed;
+};
+
+QPoint KCategorizedView::Private::blockPosition(const QString &category)
+{
+    Block &block = blocks[category];
 
-    if (listView->gridSize().isEmpty() && leftToRightFlow)
-    {
-        itemHeight = biggestItemSize.height();
-        itemWidth = biggestItemSize.width();
-    }
-    else if (leftToRightFlow)
-    {
-        itemHeight = listView->gridSize().height();
-        itemWidth = listView->gridSize().width();
-    }
-    else if (listView->gridSize().isEmpty() && !leftToRightFlow)
-    {
-        itemHeight = biggestItemSize.height();
-        itemWidth = listView->viewport()->width() - listView->spacing() * 2;
-    }
-    else
-    {
-        itemHeight = listView->gridSize().height();
-        itemWidth = listView->gridSize().width() - listView->spacing() * 2;
+    if (block.outOfQuarantine && !block.topLeft.isNull()) {
+        return block.topLeft;
     }
 
-    int itemWidthPlusSeparation = listView->spacing() + itemWidth;
-    if (!itemWidthPlusSeparation)
-        itemWidthPlusSeparation++;
-    int elementsPerRow = viewportWidth / itemWidthPlusSeparation;
-    if (!elementsPerRow)
-        elementsPerRow++;
-
-    int column;
-    int row;
+    QPoint res(categorySpacing, 0);
 
-    if (leftToRightFlow)
-    {
-        column = elementsInfo[index.row()].relativeOffsetToCategory % elementsPerRow;
-        row = elementsInfo[index.row()].relativeOffsetToCategory / elementsPerRow;
-
-        if (listView->layoutDirection() == Qt::LeftToRight)
-        {
-            retRect.setLeft(retRect.left() + column * listView->spacing() +
-                            column * itemWidth);
-        }
-        else
-        {
-            retRect.setLeft(retRect.right() - column * listView->spacing() -
-                            column * itemWidth - itemWidth);
+    const QModelIndex index = block.firstIndex;
 
-            retRect.setRight(retRect.right() - column * listView->spacing() -
-                            column * itemWidth);
+    for (QHash<QString, Private::Block>::Iterator it = blocks.begin(); it != blocks.end(); ++it) {
+        Block &block = *it;
+        const QModelIndex categoryIndex = block.firstIndex;
+        if (index.row() < categoryIndex.row()) {
+            continue;
         }
-    }
-    else
-    {
-        elementsPerRow = 1;
-        column = elementsInfo[index.row()].relativeOffsetToCategory % elementsPerRow;
-        row = elementsInfo[index.row()].relativeOffsetToCategory / elementsPerRow;
-    }
-
-    foreach (const QString &category, categories)
-    {
-        if (category == curCategory)
-            break;
-
-        float rows = (float) ((float) categoriesIndexes[category].count() /
-                              (float) elementsPerRow);
-
-        int rowsInt = categoriesIndexes[category].count() / elementsPerRow;
-
-        if (rows - trunc(rows)) rowsInt++;
-
-        retRect.setTop(retRect.top() +
-                       (rowsInt * itemHeight) +
-                       categoryDrawer->categoryHeight(index, listView->viewOptions()) +
-                       listView->spacing() * 2);
-
-        if (listView->gridSize().isEmpty())
-        {
-            retRect.setTop(retRect.top() +
-                           (rowsInt * listView->spacing()));
+        res.ry() += categoryDrawer->categoryHeight(categoryIndex, q->viewOptions()) + categorySpacing;
+        if (index.row() == categoryIndex.row()) {
+            continue;
         }
+        res.ry() += blockHeight(it.key());
     }
 
-    if (listView->gridSize().isEmpty())
-    {
-        retRect.setTop(retRect.top() + row * listView->spacing() +
-                       (row * itemHeight));
-    }
-    else
-    {
-        retRect.setTop(retRect.top() + (row * itemHeight));
-    }
-
-    retRect.setWidth(itemWidth);
-
-    QModelIndex heightIndex = proxyModel->index(index.row(), 0);
-    if (listView->gridSize().isEmpty())
-    {
-        retRect.setHeight(listView->sizeHintForIndex(heightIndex).height());
-    }
-    else
-    {
-        const QSize sizeHint = listView->sizeHintForIndex(heightIndex);
-        if (sizeHint.width() < itemWidth && leftToRightFlow) {
-            retRect.setWidth(sizeHint.width());
-            retRect.moveLeft(retRect.left() + (itemWidth - sizeHint.width()) / 2);
-        }
-        retRect.setHeight(qMin(sizeHint.height(), listView->gridSize().height()));
-    }
+    block.outOfQuarantine = true;
+    block.topLeft = res;
 
-    return retRect;
+    return res;
 }
 
-QRect KCategorizedView::Private::visualCategoryRectInViewport(const QString &category) const
+int KCategorizedView::Private::blockHeight(const QString &category)
 {
-    QRect retRect(listView->spacing(),
-                  listView->spacing(),
-                  listView->viewport()->width() - listView->spacing() * 2,
-                  0);
-
-    if (!proxyModel || !categoryDrawer || !proxyModel->isCategorizedModel() || !proxyModel->rowCount() || !categories.contains(category))
-        return QRect();
-
-    QModelIndex index = proxyModel->index(0, 0, QModelIndex());
+    Block &block = blocks[category];
 
-    int viewportWidth = listView->viewport()->width() - listView->spacing();
-
-    int itemHeight;
-    int itemWidth;
-
-    if (listView->gridSize().isEmpty())
-    {
-        itemHeight = biggestItemSize.height();
-        itemWidth = biggestItemSize.width();
-    }
-    else
-    {
-        itemHeight = listView->gridSize().height();
-        itemWidth = listView->gridSize().width();
+    if (block.collapsed) {
+        return 0;
     }
 
-    int itemWidthPlusSeparation = listView->spacing() + itemWidth;
-    int elementsPerRow = viewportWidth / itemWidthPlusSeparation;
-
-    if (!elementsPerRow)
-        elementsPerRow++;
-
-    if (listView->flow() == QListView::TopToBottom)
-    {
-        elementsPerRow = 1;
+    if (block.height > -1) {
+        return block.height;
     }
 
-    foreach (const QString &itCategory, categories)
-    {
-        if (itCategory == category)
-            break;
-
-        float rows = (float) ((float) categoriesIndexes[itCategory].count() /
-                              (float) elementsPerRow);
-        int rowsInt = categoriesIndexes[itCategory].count() / elementsPerRow;
-
-        if (rows - trunc(rows)) rowsInt++;
+    const QModelIndex firstIndex = block.firstIndex;
+    const QModelIndex lastIndex = proxyModel->index(firstIndex.row() + block.items.count() - 1, q->modelColumn(), q->rootIndex());
+    const QRect topLeft = q->visualRect(firstIndex);
+    QRect bottomRight = q->visualRect(lastIndex);
 
-        retRect.setTop(retRect.top() +
-                       (rowsInt * itemHeight) +
-                       categoryDrawer->categoryHeight(index, listView->viewOptions()) +
-                       listView->spacing() * 2);
-
-        if (listView->gridSize().isEmpty())
-        {
-            retRect.setTop(retRect.top() +
-                           (rowsInt * listView->spacing()));
+    if (hasGrid()) {
+        bottomRight.setHeight(qMax(bottomRight.height(), q->gridSize().height()));
+    } else {
+        if (!q->uniformItemSizes()) {
+            bottomRight.setHeight(highestElementInLastRow(block) + q->spacing() * 2);
         }
     }
 
-    retRect.setHeight(categoryDrawer->categoryHeight(index, listView->viewOptions()));
-
-    return retRect;
-}
-
-// We're sure elementsPosition doesn't contain index
-const QRect &KCategorizedView::Private::cacheIndex(const QModelIndex &index)
-{
-    QRect rect = visualRectInViewport(index);
-    QHash<int, QRect>::iterator it = elementsPosition.insert(index.row(), rect);
+    const int height = bottomRight.bottomRight().y() - topLeft.topLeft().y() + 1;
+    block.height = height;
 
-    return *it;
+    return height;
 }
 
-// We're sure categoriesPosition doesn't contain category
-const QRect &KCategorizedView::Private::cacheCategory(const QString &category)
+int KCategorizedView::Private::viewportWidth() const
 {
-    QRect rect = visualCategoryRectInViewport(category);
-    QHash<QString, QRect>::iterator it = categoriesPosition.insert(category, rect);
-
-    return *it;
+    return q->viewport()->width() - categorySpacing * 2 - categoryDrawer->leftMargin() - categoryDrawer->rightMargin();
 }
 
-const QRect &KCategorizedView::Private::cachedRectIndex(const QModelIndex &index)
+void KCategorizedView::Private::regenerateAllElements()
 {
-    QHash<int, QRect>::const_iterator it = elementsPosition.constFind(index.row());
-    if (it != elementsPosition.constEnd()) // If we have it cached
-    {                                        // return it
-        return *it;
-    }
-    else                                     // Otherwise, cache it
-    {                                        // and return it
-        return cacheIndex(index);
+    for (QHash<QString, Block>::Iterator it = blocks.begin(); it != blocks.end(); ++it) {
+        Block &block = *it;
+        block.outOfQuarantine = false;
+        block.quarantineStart = block.firstIndex;
+        block.height = -1;
     }
 }
 
-const QRect &KCategorizedView::Private::cachedRectCategory(const QString &category)
+void KCategorizedView::Private::rowsInserted(const QModelIndex &parent, int start, int end)
 {
-    QHash<QString, QRect>::const_iterator it = categoriesPosition.constFind(category);
-    if (it != categoriesPosition.constEnd()) // If we have it cached
-    {                                                // return it
-        return *it;
-    }
-    else                                            // Otherwise, cache it and
-    {                                               // return it
-        return cacheCategory(category);
+    if (!isCategorized()) {
+        return;
     }
-}
-
-QRect KCategorizedView::Private::visualRect(const QModelIndex &index)
-{
-    QRect retRect = cachedRectIndex(index);
-    int dx = -listView->horizontalOffset();
-    int dy = -listView->verticalOffset();
-    retRect.adjust(dx, dy, dx, dy);
 
-    return retRect;
-}
-
-QRect KCategorizedView::Private::categoryVisualRect(const QString &category)
-{
-    QRect retRect = cachedRectCategory(category);
-    int dx = -listView->horizontalOffset();
-    int dy = -listView->verticalOffset();
-    retRect.adjust(dx, dy, dx, dy);
+    for (int i = start; i <= end; ++i) {
+        const QModelIndex index = proxyModel->index(i, q->modelColumn(), parent);
 
-    return retRect;
-}
+        Q_ASSERT(index.isValid());
 
-void KCategorizedView::Private::drawNewCategory(const QModelIndex &index,
-                                                int sortRole,
-                                                const QStyleOption &option,
-                                                QPainter *painter)
-{
-    if (!index.isValid())
-    {
-        return;
-    }
+        const QString category = categoryForIndex(index);
 
-    QStyleOption optionCopy = option;
-    const QString category = proxyModel->data(index, KCategorizedSortFilterProxyModel::CategoryDisplayRole).toString();
+        Block &block = blocks[category];
 
-    optionCopy.state &= ~QStyle::State_Selected;
-
-    if ((listView->selectionMode() != SingleSelection) && (listView->selectionMode() != NoSelection)) {
-        if ((category == hoveredCategory) && !mouseButtonPressed)
-        {
-            optionCopy.state |= QStyle::State_MouseOver;
-        }
-        else if ((category == hoveredCategory) && mouseButtonPressed)
-        {
-            QPoint initialPressPosition = listView->viewport()->mapFromGlobal(QCursor::pos());
-            initialPressPosition.setY(initialPressPosition.y() + listView->verticalOffset());
-            initialPressPosition.setX(initialPressPosition.x() + listView->horizontalOffset());
-
-            if (initialPressPosition == this->initialPressPosition)
-            {
-                optionCopy.state |= QStyle::State_Selected;
-            }
+        //BEGIN: update firstIndex
+        // save as firstIndex in block if
+        //     - it forced the category creation (first element on this category)
+        //     - it is before the first row on that category
+        const QModelIndex firstIndex = block.firstIndex;
+        if (!firstIndex.isValid() || index.row() < firstIndex.row()) {
+            block.firstIndex = index;
         }
-    }
+        //END: update firstIndex
 
-    categoryDrawer->drawCategory(index,
-                                 sortRole,
-                                 optionCopy,
-                                 painter);
-}
+        Q_ASSERT(block.firstIndex.isValid());
 
+        const int firstIndexRow = block.firstIndex.row();
 
-void KCategorizedView::Private::updateScrollbars()
-{
-    // find the last index in the last category
-    QModelIndex lastIndex = categoriesIndexes.isEmpty() ? QModelIndex() : categoriesIndexes[categories.last()].last();
+        block.items.insert(index.row() - firstIndexRow, Private::Item());
 
-    int lastItemBottom = cachedRectIndex(lastIndex).top() +
-                         listView->spacing() + (listView->gridSize().isEmpty() ? biggestItemSize.height() : listView->gridSize().height()) - listView->viewport()->height();
+        //TODO: assign less times
+        block.height = -1;
 
-    listView->horizontalScrollBar()->setRange(0, 0);
+        q->visualRect(index);
+        q->viewport()->update();
+    }
 
-    if (listView->verticalScrollMode() == QAbstractItemView::ScrollPerItem)
+    //BEGIN: update the items that are in quarantine in affected categories
     {
-        listView->setVerticalScrollMode(QAbstractItemView::ScrollPerPixel);
+        const QModelIndex lastIndex = proxyModel->index(end, q->modelColumn(), parent);
+        const QString category = categoryForIndex(lastIndex);
+        Private::Block &block = blocks[category];
+        block.quarantineStart = block.firstIndex;
     }
+    //END: update the items that are in quarantine in affected categories
 
-    if (listView->horizontalScrollMode() == QAbstractItemView::ScrollPerItem)
+    //BEGIN: mark as in quarantine those categories that are under the affected ones
     {
-        listView->setHorizontalScrollMode(QAbstractItemView::ScrollPerPixel);
+        const QModelIndex firstIndex = proxyModel->index(start, q->modelColumn(), parent);
+        const QString category = categoryForIndex(firstIndex);
+        const QModelIndex firstAffectedCategory = blocks[category].firstIndex;
+        //BEGIN: order for marking as alternate those blocks that are alternate
+        QList<Block> blockList = blocks.values();
+        qSort(blockList.begin(), blockList.end(), Block::lessThan);
+        QList<int> firstIndexesRows;
+        foreach (const Block &block, blockList) {
+            firstIndexesRows << block.firstIndex.row();
+        }
+        //END: order for marking as alternate those blocks that are alternate
+        for (QHash<QString, Private::Block>::Iterator it = blocks.begin(); it != blocks.end(); ++it) {
+            Private::Block &block = *it;
+            if (block.firstIndex.row() > firstAffectedCategory.row()) {
+                block.outOfQuarantine = false;
+                block.alternate = firstIndexesRows.indexOf(block.firstIndex.row()) % 2;
+            } else if (block.firstIndex.row() == firstAffectedCategory.row()) {
+                block.alternate = firstIndexesRows.indexOf(block.firstIndex.row()) % 2;
+            }
+        }
     }
-
-    listView->verticalScrollBar()->setSingleStep(listView->viewport()->height() / 10);
-    listView->verticalScrollBar()->setPageStep(listView->viewport()->height());
-    listView->verticalScrollBar()->setRange(0, lastItemBottom);
+    //END: mark as in quarantine those categories that are under the affected ones
 }
 
-void KCategorizedView::Private::drawDraggedItems(QPainter *painter)
+QRect KCategorizedView::Private::mapToViewport(const QRect &rect) const
 {
-    QStyleOptionViewItemV4 option = listView->viewOptions();
-    option.state &= ~QStyle::State_MouseOver;
-    foreach (const QModelIndex &index, listView->selectionModel()->selectedIndexes())
-    {
-        const int dx = mousePosition.x() - initialPressPosition.x() + listView->horizontalOffset();
-        const int dy = mousePosition.y() - initialPressPosition.y() + listView->verticalOffset();
-
-        option.rect = visualRect(index);
-        option.rect.adjust(dx, dy, dx, dy);
+    const int dx = -q->horizontalOffset();
+    const int dy = -q->verticalOffset();
+    return rect.adjusted(dx, dy, dx, dy);
+}
 
-        if (option.rect.intersects(listView->viewport()->rect()))
-        {
-            listView->itemDelegate(index)->paint(painter, option, index);
-        }
-    }
+QRect KCategorizedView::Private::mapFromViewport(const QRect &rect) const
+{
+    const int dx = q->horizontalOffset();
+    const int dy = q->verticalOffset();
+    return rect.adjusted(dx, dy, dx, dy);
 }
 
-void KCategorizedView::Private::layoutChanged(bool forceItemReload)
+int KCategorizedView::Private::highestElementInLastRow(const Block &block) const
 {
-    if (proxyModel && categoryDrawer && proxyModel->isCategorizedModel() &&
-        ((forceItemReload ||
-          (modelSortRole != proxyModel->sortRole()) ||
-          (modelSortColumn != proxyModel->sortColumn()) ||
-          (modelSortOrder != proxyModel->sortOrder()) ||
-          (modelLastRowCount != proxyModel->rowCount()) ||
-          (modelCategorized != proxyModel->isCategorizedModel()))))
-    {
-        // Force the view to update all elements
-        listView->rowsInsertedArtifficial(QModelIndex(), 0, proxyModel->rowCount() - 1);
-
-        if (!forceItemReload)
-        {
-            modelSortRole = proxyModel->sortRole();
-            modelSortColumn = proxyModel->sortColumn();
-            modelSortOrder = proxyModel->sortOrder();
-            modelLastRowCount = proxyModel->rowCount();
-            modelCategorized = proxyModel->isCategorizedModel();
+    //Find the highest element in the last row
+    const QModelIndex lastIndex = proxyModel->index(block.firstIndex.row() + block.items.count() - 1, q->modelColumn(), q->rootIndex());
+    QModelIndex prevIndex = proxyModel->index(lastIndex.row(), q->modelColumn(), q->rootIndex());
+    QRect prevRect = q->visualRect(prevIndex);
+    int res = prevRect.height();
+    Q_FOREVER {
+        prevIndex = proxyModel->index(prevIndex.row() - 1, q->modelColumn(), q->rootIndex());
+        const QRect tempRect = q->visualRect(prevIndex);
+        if (tempRect.topLeft().y() < prevRect.topLeft().y()) {
+            break;
+        }
+        res = qMax(res, tempRect.height());
+        if (prevIndex == block.firstIndex) {
+            break;
         }
     }
 
-    if (proxyModel && categoryDrawer && proxyModel->isCategorizedModel())
-    {
-        updateScrollbars();
-    }
+    return res;
 }
 
-void KCategorizedView::Private::drawDraggedItems()
+bool KCategorizedView::Private::hasGrid() const
 {
-    QRect rectToUpdate;
-    QRect currentRect;
-    foreach (const QModelIndex &index, listView->selectionModel()->selectedIndexes())
-    {
-        int dx = mousePosition.x() - initialPressPosition.x() + listView->horizontalOffset();
-        int dy = mousePosition.y() - initialPressPosition.y() + listView->verticalOffset();
-
-        currentRect = visualRect(index);
-        currentRect.adjust(dx, dy, dx, dy);
-
-        if (currentRect.intersects(listView->viewport()->rect()))
-        {
-            rectToUpdate = rectToUpdate.united(currentRect);
-        }
-    }
-
-    listView->viewport()->update(lastDraggedItemsRect.united(rectToUpdate));
+    const QSize gridSize = q->gridSize();
+    return gridSize.isValid() && !gridSize.isNull();
+}
 
-    lastDraggedItemsRect = rectToUpdate;
+QString KCategorizedView::Private::categoryForIndex(const QModelIndex &index) const
+{
+    const QModelIndex categoryIndex = index.model()->index(index.row(), proxyModel->sortColumn(), index.parent());
+    return categoryIndex.data(KCategorizedSortFilterProxyModel::CategoryDisplayRole).toString();
 }
 
+void KCategorizedView::Private::_k_slotCollapseOrExpandClicked()
+{
+}
 
-//==============================================================================
+//END: Private part
 
+//BEGIN: Public part
 
 KCategorizedView::KCategorizedView(QWidget *parent)
     : QListView(parent)
